server='pop3.domain'
user='user'
password='password'

if RxFuncQuery('SysLoadFuncs') then
  do
    call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
    call SysLoadFuncs
  end
if RxFuncQuery('SockLoadFuncs') then
  do
    call RxFuncAdd 'SockLoadFuncs','RxSock','SockLoadFuncs'
    call SockLoadFuncs
  end

if SockGetHostByName(server,'host.!')=0 then return Error(-1,1)
server=host.!addr
sock=SockSocket('AF_INET','SOCK_STREAM','IPPROTO_TCP')
if sock=-1 then return Error(-1,2)
server.!family='AF_INET'
server.!port=110
server.!addr=server
if SockConnect(sock,'server.!')=-1 then return Error(sock,3)
call GetResponse sock
if SendMessage(sock,'USER 'user)='!err' then return Error(sock,11)
call GetResponse sock
parse var line.1 status rest
if status<>'+OK' then
  do
    call CloseSession
    return Error(sock,4)
  end
if SendMessage(sock,'PASS 'password)='!err' then return Error(sock,11)
call GetResponse sock
parse var line.1 status rest
if status<>'+OK' then
  do
    call CloseSession
    return Error(sock,5)
  end
if SendMessage(sock,'LIST')='!err' then return Error(sock,11)
call GetResponse sock
messages=0; sizem=0
do forever
  msginfo=GetResponseLine(sock)
  if msginfo='.' then leave
  if msginfo='!err' then return Error(sock,10)
  messages=messages+1
  parse var msginfo number size
  sizem=sizem+size
end
call CloseSession
call SockSoclose sock
if messages=0 then text=' '
else
  do
    if messages=1 then s=''
    else s='s'
    text=Translate(server)': 'messages'  letter's'  ('SetDelimiter(sizem)'b)'
  end
return text

SetDelimiter:
parse arg n
s=''; i=Length(n); j=0
do while i>0
  j=j+1
  if j=4 then
    do
      j=1; d=','
    end
  else d=''
  s=Substr(n,i,1)''d''s
  i=i-1
end
return s

GetResponse: procedure expose !. line.
sock=arg(1)
moreids='100 215 220 221 222 223 230 231'
line.0=1
line.1=GetResponseLine(sock)
parse var line.1 rid' '.
if WordPos(rid,moreids)=0 then return ''
do forever
  o=line.0+1
  line.o=GetResponseLine(sock)
  if line.o='.' then return ''
  line.0=o
end
return ''

GetResponseLine: procedure expose !.
parse arg sock
crlf=d2c(13)''d2c(10)
if Symbol('!.buff')='LIT' then !.buff=''
do while Pos(crlf,!.buff)=0
  if SockRecv(sock,'data',8000)<0 then return '!err'
  !.buff=!.buff''data
end
p=Pos(crlf,!.buff)
line=SubStr(!.buff,1,p-1)
!.buff=SubStr(!.buff,p+2)
return line

SendMessage: procedure
parse arg socket,data
data=data''d2c(13)''d2c(10)
rc=0
do while rc<Length(data)
  rc=SockSend(socket,data)
  if rc<0 then return '!err'
  if rc<Length(data) then
    do
      data=SubStr(data,rc+1)
      rc=0
    end
end
return rc

CloseSession:
if SendMessage(sock,'QUIT')='!err' then return Error(sock,11)
return ''

Halting:
Error(sock,255)

Error: procedure
parse arg sock,err
if (sock<>-1) then rc=SockSoClose(sock)
return 'error: 'err
